# pad-left [![NPM version](https://badge.fury.io/js/pad-left.svg)](http://badge.fury.io/js/pad-left)

> Left pad a string with zeros or a specified string. Fastest implementation.

## Install with [npm](npmjs.org)

```bash
npm i pad-left --save
```

## Usage

```js
var pad = require('pad-left');
pad('abc', 10);
//=> '          abc'

pad('abc', 10, '~');
//=> '~~~~~~~~~~abc'
```

## Related projects

Other awesome node.js libraries for padding and aligning strings.

* [align-text](https://github.com/jonschlinkert/align-text): Align the text in a string.
* [center-align](https://github.com/jonschlinkert/center-align): Center-align the text in a string.
* [justified](https://github.com/jonschlinkert/justified): Wrap words to a specified length and justified the text.
* [pad-right](https://github.com/jonschlinkert/pad-right): Right pad a string with zeros or a specified string. Fastest implementation.
* [repeat-string](https://github.com/jonschlinkert/repeat-string): Repeat the given string n times. Fastest implementation for repeating a string.
* [right-align](https://github.com/jonschlinkert/right-align): Right-align the text in a string.
* [word-wrap](https://github.com/jonschlinkert/word-wrap): Wrap words to a specified length.

## Running tests

Install dev dependencies:

```bash
npm i -d && npm test
```

## Contributing

Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](https://github.com/jonschlinkert/pad-left/issues)

## Author

**Jon Schlinkert**

+ [github/jonschlinkert](https://github.com/jonschlinkert)
+ [twitter/jonschlinkert](http://twitter.com/jonschlinkert)

## License

Copyright (c) 2014-2015 Jon Schlinkert
Released under the MIT license.

***

_This file was generated by [verb-cli](https://github.com/assemble/verb-cli) on April 27, 2015._

<!-- reflinks generated by verb-reflinks plugin -->

[assemble]: http://assemble.io
[template]: https://github.com/jonschlinkert/template
[verb]: https://github.com/assemble/verb